## buffer 1.17

=== Makefile ===
# Make the buffer program

# Add -DSYS5 for A System 5 (USG) version of unix
#   You should also add -DSYS5 for Ultrix, AIX, and Solarix.
# Add -DDEF_SHMEM=n if you can only have n bytes of shared memory
#   (eg: -DDEF_SHMEM=524288 if you can only have half a meg.)
CFLAGS=

# Where to install buffer and its manual pages
INSTBIN=/usr/local/bin
INSTMAN=/usr/man/manl
# The manual page section (normally l or 1)
S=l

RM=/bin/rm
ALL=README buffer.man Makefile buffer.c sem.c COPYING

all: buffer

buffer: buffer.o sem.o
	$(CC) -o buffer $(CFLAGS) buffer.o sem.o

clean:
	$(RM) -f *.o core buffer .merrs

install: buffer
	rm -f $(INSTBIN)/buffer
	cp buffer $(INSTBIN)/buffer
	chmod 111 $(INSTBIN)/buffer
	rm -f $(INSTMAN)/buffer.$S
	cp buffer.man $(INSTMAN)/buffer.$S
	chmod 444 $(INSTMAN)/buffer.$S

buffer.tar: $(ALL)
	$(RM) -f buffer.tar
	tar cvf buffer.tar $(ALL)

buffer.shar: $(ALL)
	$(RM) -f buffer.shar
	shar $(ALL) > buffer.shar

## buffer 1.19

=== Makefile ===
--- 
+++ 
@@ -1,10 +1,16 @@
 # Make the buffer program
 
-# Add -DSYS5 for A System 5 (USG) version of unix
-#   You should also add -DSYS5 for Ultrix, AIX, and Solarix.
+# You might need to add the following to CGFLAGS:
+#
+# Add -DSYS5 for A System 5 (USG) version of Unix
+#   You should also add -DSYS5 for Ultrix, AIX, and Solaris.
 # Add -DDEF_SHMEM=n if you can only have n bytes of shared memory
 #   (eg: -DDEF_SHMEM=524288 if you can only have half a meg.)
-CFLAGS=
+# Add -DAMPEX to change the default settings suitable for the high capacity
+#   Ampex drives, such as the DST 310.
+
+CC=gcc
+CFLAGS=-Wall
 
 # Where to install buffer and its manual pages
 INSTBIN=/usr/local/bin
@@ -13,7 +19,7 @@
 S=l
 
 RM=/bin/rm
-ALL=README buffer.man Makefile buffer.c sem.c COPYING
+ALL=README buffer.man Makefile buffer.c sem.c sem.h COPYING
 
 all: buffer

=== debian/changelog ===
buffer (1.19-12) unstable; urgency=low

  * Use dpkg-buildflags
  * Upgraded to Standards-Version 3.9.5.0 (no changes required)
  * Added simple functionality checks after build

 -- Martin Buck <mbuck@debian.org>  Wed, 10 Sep 2014 00:30:39 +0200

buffer (1.19-11) unstable; urgency=low

  * Documented undocumented options. Closes: #608637
  * Documented buffer size limits. Closes: #561938
  * Switched to debhelper compatibility level 8
  * Switched to dpkg-source 3.0 (quilt) format
  * Split large autogenerated quilt patch into separate ones
  * Implemented build-arch/build-indep targets
  * Upgraded to Standards-Version 3.9.3.0 (no changes required)

 -- Martin Buck <mbuck@debian.org>  Thu, 21 Jun 2012 12:47:30 +0200

buffer (1.19-10) unstable; urgency=low

  * Fixed shared memory mapping to guarantee same address space in both
    parent and child process. Closes: #428105
  * Made lintian happy:
    - Fixed copyright file
    - Moved debhelper compat level to debian/compat
    - Don't ignore "make clean" errors
  * Upgraded to Standards-Version 3.7.3.0 (no changes required)

 -- Martin Buck <mbuck@debian.org>  Fri,  9 May 2008 16:09:42 +0200

buffer (1.19-9) unstable; urgency=low

  * Applied patch from Petr Salinger for GNU/kFreeBSD compatibility.
    Closes: #401743
  * Upgraded to Standards-Version 3.7.2.2 (no changes required)

 -- Martin Buck <mbuck@debian.org>  Fri,  9 Mar 2007 16:00:12 +0100

buffer (1.19-8) unstable; urgency=low

  * Applied patch from A. Costa to fix typos in manpage. Closes: #377637
  * Added lintian override for bogus warning about package description
  * Upgraded to Standards-Version 3.6.2.2 (no changes required)

 -- Martin Buck <mbuck@debian.org>  Wed, 12 Jul 2006 09:50:29 +0200

buffer (1.19-7) unstable; urgency=low

  * Really changed priority this time. Sigh.

 -- Martin Buck <mbuck@debian.org>  Sat,  1 Jan 2005 23:46:26 +0100

buffer (1.19-6) unstable; urgency=low

  * Changed priority to optional. Closes: #283803

 -- Martin Buck <mbuck@debian.org>  Thu, 30 Dec 2004 15:04:31 +0100

buffer (1.19-5) unstable; urgency=low

  * Disabled obsolete declaration of shmat(). Closes: #260395

 -- Martin Buck <mbuck@debian.org>  Tue, 27 Jul 2004 23:50:50 +0200

buffer (1.19-4) unstable; urgency=low

  * Fixed hang when using option "-p 100". Closes: #224984

 -- Martin Buck <mbuck@debian.org>  Sun, 11 Jan 2004 23:20:39 +0100

buffer (1.19-3) unstable; urgency=low

  * Added largefile support. Closes: #156847
  * Made sure -S/-z works properly with files > 4 TB.
  * Upgraded to Standards-Version 3.5.8

 -- Martin Buck <mbuck@debian.org>  Fri, 31 Jan 2003 23:55:43 +0100

buffer (1.19-2) unstable; urgency=low

  * Fixed buffer overrun in option parsing.
    Fixed (rather theoretical) potential division by zero in
    throughput calculation.
    Closes: #123543

 -- Martin Buck <mbuck@debian.org>  Tue, 11 Dec 2001 23:34:46 +0100

buffer (1.19-1) unstable; urgency=low

  * New upstream version. Closes: #91961
  * Added a few spelling fixes from FreeBSD version 1.17.1
  * Added (slightly modified version of) patch from Marc Schaefer that prints
    the throughput with option -S
  * Fixed a few gcc warnings

 -- Martin Buck <mbuck@debian.org>  Thu,  5 Apr 2001 22:10:07 +0200

buffer (1.17-6) unstable; urgency=low

  * Added Build-Depends. Closes: #70332

 -- Martin Buck <mbuck@debian.org>  Mon,  5 Mar 2001 22:19:09 +0100

buffer (1.17-5) unstable; urgency=low

  * Cleaned up debian/rules
  * Upgraded to Debian policy 3.0.1.1

 -- Martin Buck <mbuck@debian.org>  Mon, 13 Sep 1999 23:19:57 +0200

buffer (1.17-4) unstable; urgency=low

  * buffer now complains if non-option arguments are found
  * Document changes from original version in copyright-file
  * Checked conformance with Debian policy 2.5.0

 -- Martin Buck <mbuck@debian.org>  Sun, 29 Aug 1999 00:57:03 +0200

buffer (1.17-3) unstable; urgency=low

  * NMU;  added missing SEM_SEMUN_UNDEFINED 
  * closes: #31931
  * fixes: #31920

 -- Hartmut Koptein <koptein@debian.org>  Fri,  9 Jul 1999 10:04:49 +0200

buffer (1.17-2) unstable; urgency=low

  * Applied patch from Paul Slootman (closes: Bug#26098):
    - egcs complains about NULL where union expected. Now it builds on Alpha.
    - typos in manpage fixed.
  * Switched from debstd to debhelper

 -- Martin Buck <mbuck@debian.org>  Wed,  9 Sep 1998 22:35:29 +0200

buffer (1.17-1) unstable; urgency=low

  * Initial Release.

 -- Martin Buck <mbuck@debian.org>  Wed, 27 Aug 1997 01:11:29 +0200

Local variables:
mode: debian-changelog
End:

=== debian/control ===
Source: buffer
Section: utils
Priority: optional
Maintainer: Martin Buck <mbuck@debian.org>
Standards-Version: 3.9.5.0
Build-Depends: debhelper (>= 8)

Package: buffer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Buffering/reblocking program for tape backups, printing, etc.
 Buffer implements double buffering and can be used to keep backup tapes
 streaming or printers printing. It can also be used to convert a data
 stream to a given output blocksize.
 .
 Buffer uses shared memory to convert a variable input data rate to a
 constant output data rate. It is typically used in a pipe between a backup
 program and the tape device, but there are also other applications like
 buffering printer data in lpd's input filter.

=== debian/rules ===
#!/usr/bin/make -f

DEB_CFLAGS_MAINT_APPEND = -Wall -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

.PHONY: build
build: build-arch build-indep

.PHONY: build-arch
build-arch: build-stamp

.PHONY: build-indep
build-indep: build-stamp

build-stamp:
	dh_testdir
	make CFLAGS="$(CFLAGS) $(CPPFLAGS)" LDFLAGS="$(LDFLAGS)"
ifeq (, $(filter nocheck,$(DEB_BUILD_OPTIONS)))
	make check
endif
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	-rm -f build-stamp install-stamp
	make clean
	dh_clean

install: install-stamp
install-stamp: build-stamp
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs usr/bin usr/share/man/man1 usr/share/lintian/overrides
	make install INSTBIN=debian/buffer/usr/bin INSTMAN=debian/buffer/usr/share/man/man1 S=1
	touch install-stamp
	
binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs README
#	dh_installexamples
#	dh_installmenu
#	dh_installemacsen
#	dh_installinit
#	dh_installcron
#	dh_installman
#	dh_undocumented
	dh_installchangelogs
	install -m 644 debian/buffer.lintian-override debian/buffer/usr/share/lintian/overrides/buffer
	dh_strip
	dh_compress
	dh_fixperms
#	dh_suidregister
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
#	dh_makeshlibs
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## buffer overwrites

=== bounds/lib/Makefile ===
#	Makefile for:
#	----------------------------------------------------------------------
#	Bounds Checking Project, by Richard W.M. Jones.
#	Library of checking functions linked by modified GCC.
#	----------------------------------------------------------------------

# The following mods from Mark W. Snitily should solve cross-compilation
# problems.	(RWMJ)
# ---
#
#  This makefile is run by the gcc dir's makefile:
#  thisdir1=`pwd`; \
#  srcdir1=`cd $(srcdir); pwd`; \
#  cd bounds/lib; \
#  $(MAKE) $(MAKEFLAGS) -f $$srcdir1/bounds/lib/Makefile libcheck.a \
#    srcdir=$$srcdir1 tooldir=$(tooldir) AR="$(AR)" AR_FLAGS="$(AR_FLAGS)" \
#    GCC_FOR_TARGET="$$thisdir1/xgcc -B$$thisdir1/" \
#    GCC_CFLAGS="$(GCC_CFLAGS)" incinstalldir=$$thisdir1/include
#  Two targets are used by ../Makefile: `all' and `mostlyclean'.

SHELL	= /bin/sh

OPTIMIZE= -O2

VPATH = $(srcdir)/bounds/lib

# Always search these dirs when compiling.
SUBDIR_INCLUDES = -I../.. -I$(srcdir)/bounds/lib -I$(srcdir) -I$(srcdir)/config

.c.o:
	$(GCC_FOR_TARGET) -Wall $(OPTIMIZE) \
		-c $(GCC_CFLAGS) $(SUBDIR_INCLUDES) $<

# If we were not invoked from the gcc dir invoke make
# in the gcc dir and reinvoke this makefile.
# That's necessary to get the right values for srcdir, etc.
all:
	cd ../..; $(MAKE) CFLAGS="$(CFLAGS)" sublibcheck.a

OBJS	= alloca.o check.o error.o exstatics.o functions.o globals.o init.o \
	  malloc/gmalloc.o objects.o print.o string.o
HEADERS = alloca.h bounds-lib.h check.h ext-tree.h functions.h \
	  mutex.h objects.h version.h ../VERSION

MAKE	= make
RM	= rm -f

# This is where `libcheck.a' ends up (in the gcc-x.x.x home directory).
INSTDIR	= $(srcdir)

mostlyclean:
	$(RM) libcheck.a $(OBJS) core
	cd malloc; $(MAKE) -f $(srcdir)/bounds/lib/malloc/Makefile clean

distclean: clean
	$(RM) *~ *.BAK

clean: mostlyclean
extraclean: mostlyclean

install: libcheck.a
	cp libcheck.a $(INSTDIR)/libcheck.a

libcheck.a: $(OBJS)
	$(RM) libcheck.a
	$(AR) $(AR_FLAGS) libcheck.a $(OBJS)
# ranlib is run in the parent directory's makefile.

alloca.o: $(srcdir)/bounds/lib/alloca.c
	$(GCC_FOR_TARGET) -fno-builtin -Wall $(OPTIMIZE) \
		-c $(GCC_CFLAGS) $(SUBDIR_INCLUDES) \
		$(srcdir)/bounds/lib/alloca.c -o alloca.o

string.o: $(srcdir)/bounds/lib/string.c
	$(GCC_FOR_TARGET) -fno-builtin -Wall $(OPTIMIZE) \
		-c $(GCC_CFLAGS) $(SUBDIR_INCLUDES) \
		$(srcdir)/bounds/lib/string.c -o string.o

malloc/gmalloc.o:
	if [ -d malloc ]; then true; else mkdir malloc; fi; \
	cd malloc; \
	$(MAKE) -f $(srcdir)/bounds/lib/malloc/Makefile gmalloc.o \
	  srcdir=$(srcdir) tooldir=$(tooldir) AR="$(AR)" AR_FLAGS="$(AR_FLAGS)" \
	  GCC_FOR_TARGET="$(GCC_FOR_TARGET)/" \
	  GCC_CFLAGS="$(GCC_CFLAGS)"

$(OBJS): $(HEADERS)

=== bounds/tests/Makefile ===
#	Automatic tests for the bounds checking library.
#	By Richard W.M. Jones. June - July, '95.

# You can use the following make targets:
#	make all
#		- Compile test program and do all the tests
#	make clean
#		- Clean up object files and program
#	make distclean
#		- Same as `make clean'.
#	make veryclean
#		- Clean up `*.res' files too (** NOT recommended **).
#	make results
#		- Remake all `*.res' files (** NOT recommended **).
#	make TESTS="0 1 2" results
#		- Remake result files for tests 0, 1, 2. Only use this if you
#		know what you're doing: eg. if you've just added another test
#		to the program. Check the result file `test-xyz.res' by hand
#		before you use it.

#----------------------------------------------------------------------

# The directory where you compiled GCC. `../..' should be OK if these tests
# are left in `bounds/tests' subdirectory.

GCCDIR	= ../..

#----------------------------------------------------------------------

# Command used to run the compiler with bounds checking.

CC	= $(GCCDIR)/xgcc -B$(GCCDIR)/
BCOPTS	= -fbounds-checking -fno-builtin

# Other flags here. `-O' or `-O2' is recommended to check there are no
# problems with optimizing bounds checked code.

CCOPTS	= -O2 -Wall

# Include files, if necessary.

INCOPTS	=

# The complete list of flags.

CFLAGS	= $(BCOPTS) $(CCOPTS) $(INCOPTS)

# Object files making up program.

OBJS	= general-test.o

# Program name.

PROG	= general-test

# Libraries.

LIBS	=

#----------------------------------------------------------------------

SHELL	= /bin/sh

all: tests

distclean: clean

clean:
	rm -f $(OBJS) $(PROG) core *~ *.bak *.BAK *.old

# Don't use the following rule unless you know what you're doing ...
veryclean: clean
	rm -f *.res *.res.old

tests: $(PROG)
	@echo "Performing tests ..."; \
	GCC_BOUNDS_OPTS="-no-message -no-warn-unchecked-statics \
		-no-warn-unchecked-stack -no-warn-free-null \
		-no-warn-misc-strings -no-statistics"; export GCC_BOUNDS_OPTS;\
	if ./$(PROG); then \
		echo "Tests OK."; \
	else \
		echo "*** Error during tests."; \
	fi

$(PROG): $(OBJS)
	$(CC) $(CFLAGS) $(OBJS) $(LIBS) -o $(PROG)

.c.o:
	$(CC) $(CFLAGS) -c $< -o $@

#----------------------------------------------------------------------

# Remake the results files. This assumes that the program is currently
# working. Normally you should never need to do this. Use the following
# make command:
#	make TESTS="3 4 5" results
# (remakes results of tests 3, 4 and 5) or:
#	make TESTS=all results
#	make results
# (both remake all tests).
#
# Commentary (you will probably never need to know this):
# The rule for remaking the results files is a single `sh' command which
# automatically runs `general-test -$ -test N' for each test number `N'
# and processes the output with `sed'. In particular, we delete specific
# pointer values, since these will vary from machine to machine and day
# to day. The important thing is that we recognize pointers as NULL (0),
# ILLEGAL (-1) or ``other''. Notice that `general-test' writes pointers
# in the form `ptrnn-0xpppp' where `nn' is the pointer size (16, 32 or
# 64 bits) and `pppp' is the actual pointer value. This is so we can safely
# parse these pointers here. Also we convert 0xffff -> ILLEGAL -> 0xffff
# in the `sed' script. This is so it doesn't get mangled into `0x....' by
# the intervening lines in the script.
#
# The automatic processing done by `sed' here isn't foolproof, so you'll
# need to examine the results by hand if you add your own tests.

results: $(PROG)
	@GCC_BOUNDS_OPTS="-no-message -no-warn-unchecked-statics \
		-no-warn-unchecked-stack -no-warn-free-null \
		-no-warn-misc-strings -no-statistics"; export GCC_BOUNDS_OPTS;\
	if [ "x$(TESTS)" = xall -o "x$(TESTS)" = "x" ]; then \
		tests=`grep 'define.*NR_TESTS' general-test.c | \
			head -1 | \
			awk '{for (i = 0; i < $$3; ++i) print i;}'`; \
	else \
		tests="$(TESTS)"; \
	fi; \
	for test in $$tests; do \
		echo Making file test-$$test.res; \
		if [ -f test-$$test.res ]; then \
			mv test-$$test.res test-$$test.res.old; \
		fi; \
		./$(PROG) -$$ -test $$test 2>&1 | \
		sed -e 's/ointer value: 0x.*/ointer value: */g' \
		    -e 's/ddress in memory:    0x.*/ddress in memory:    */g' \
		    -e 's/ptr16-0xffff/ptr16-ILLEGAL/g' \
		    -e 's/ptr32-0xffffffff/ptr32-ILLEGAL/g' \
		    -e 's/ptr64-0xffffffffffffffff/ptr64-ILLEGAL/g' \
		    -e 's/ptr16-0xffff/ptr16-NULL/g' \
		    -e 's/ptr32-0x00000000/ptr32-NULL/g' \
		    -e 's/ptr64-0x0000000000000000/ptr64-NULL/g' \
		    -e 's/ptr16-0x[0-9a-f][0-9a-f][0-9a-f][0-9a-f]/ptr16-0x..../g' \
		    -e 's/ptr32-0x[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]/ptr32-0x......../g' \
		    -e 's/ptr64-0x[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]/ptr64-0x................/g' \
		    -e 's/ptr16-ILLEGAL/ptr16-0xffff/g' \
		    -e 's/ptr32-ILLEGAL/ptr32-0xffffffff/g' \
		    -e 's/ptr64-ILLEGAL/ptr64-0xffffffffffffffff/g' \
		    -e 's/ptr16-NULL/ptr16-0x0000/g' \
		    -e 's/ptr32-NULL/ptr32-0x00000000/g' \
		    -e 's/ptr64-NULL/ptr64-0x0000000000000000/g' \
		    -e '/IOT trap\/Abort/d' > test-$$test.res; \
	done

=== bounds/tools/Makefile ===
# *----------------------------------------------------------------------*
# * Bounds Checking for GCC.						 *
# * Copyright (C) 1995 Richard W.M. Jones <rwmj@doc.ic.ac.uk>.		 *
# *----------------------------------------------------------------------*
# * This program is free software; you can redistribute it and/or modify *
# * it under the terms of the GNU General Public License as published by *
# * the Free Software Foundation; either version 2 of the License, or	 *
# * (at your option) any later version.					 *
# *									 *
# * This program is distributed in the hope that it will be useful,	 *
# * but WITHOUT ANY WARRANTY; without even the implied warranty of	 *
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	 *
# * GNU General Public License for more details.			 *
# *									 *
# * You should have received a copy of the GNU General Public License	 *
# * along with this program; if not, write to the Free Software		 *
# * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.		 *
# *----------------------------------------------------------------------*
# * File:
# *	tools/Makefile
# * Summary:
# *	See README file.
# * Other notes:
# *	
# * Author      	Date		Notes
# * 
# *----------------------------------------------------------------------*

CC	= ../../xgcc
CFLAGS	= -Wall -O -B../../

SHELL	= /bin/sh

# You will need the `BFD' library which is commonly distributed with Gnu
# GDB, or you may have it installed already. Place the line needed to link
# it here:
BFD_LIB	= -lbfd

all:	grab-statics

distclean: clean

clean:
	rm -f find-objects string-subst grab-statics *.o *~ *.bak *.BAK core \
		statics-*.o

grab-statics: grab-statics.in string-subst find-objects
	cat grab-statics.in | \
		./string-subst @w@ 'Caution! This file is automatically generated. Edits will be lost!' | \
		./string-subst @tools_dir@ `pwd` | \
		./string-subst @output_dir@ `pwd` | \
		./string-subst @lib_dir@ `cd ../..; pwd` | \
		./string-subst @gcc@ `cd ../..; pwd`/xgcc | \
		./string-subst @gcc_flags@ "-B`cd ../..; pwd`/ -fno-builtin -g" \
			> grab-statics
	chmod 0755 grab-statics

string-subst: string-subst.o
	$(CC) $(CFLAGS) $< -o $@

find-objects: find-objects.o
	$(CC) $(CFLAGS) $< $(BFD_LIB) -o $@
